/*
 * libsbook.h
 * Copyright (C) 1992, 1992, 2000 Simson L. Garfinkel
 * All rights reserved.
 *
 * The SBook matching routines
 */


#ifndef _LIBSBOOK_H
#define _LIBSBOOK_H

#include "nxatom.h"
#include <qstring.h>

NXAtomList &atomsForNames(const QString &str);
NXAtom	smartSortName(const char *theLine,NXAtomList &atoms);
bool	isOnlyDigits(const char *str);

//
//	Parser flags
//
#define P_NAME			0x20000
#define P_TELEPHONE		0x001
#define P_EMAIL 		0x002
#define P_LABEL			0x004
#define P_ZIP			0x008
#define P_BLANKLINE		0x010
#define P_ADDRESS		0x020
#define P_PUSHBUTTON		0x040
#define P_WEAK			0x080		/* not as strong */
#define P_COUNTRY		0x100
#define P_CITY			0x200		/* a state or country abbreviation */
#define P_STATE			0x400
#define P_DIRECTIONS		0x1000		/* probably directions, not definate */
#define P_STREET		0x2000  
#define P_ORG			0x4000		/* looks like an organization */
#define P_NEWS			0x8000		/* north, south, east or west */
#define P_OFFICE		0x10000		/* office, company, one of those names */


//
//	P_NOT_ADDRESS is definately not an address line
//
#define P_NOT_ADDRESS  (P_NAME|P_TELEPHONE|P_EMAIL|P_LABEL|P_BLANKLINE)

int	parse_address(const char *buf);
int	parse_case(const char *buf);
int	parse_company(const char *buf);



#endif
