%{
//
//	Copyright (C) 1991, 1992, 2000 Simson L. Garfinkel
//	All rights reserved.
//

#include "libsbook.h"
#include "flexhdr.h"

static	int	aflag;

			
%}

S	[ ]
W	[ ][A-Z]+[ ]+
END	[^a-zA-Z]
P	[., ]
ZIP	[0-9]{5}((-[0-9]{4})?)

STATE	((alabama)|(alaska)|(arizona)|(arkansas)|(california)|(canal[ ]zone)|(colorado)|(connecticut)|(deleware)|(florida)|(georgia)|(guam)|(hawaii)|(idaho)|(illinois)|(indiana)|(iowa)|(kansas)|(kentucky)|(louisiana)|(maine)|(maryland)|(massachusetts)|(michigan)|(minnesota)|(minn)|(mississippi)|(missouri)|(montana)|(nebraska)|(nevada)|(new[ ]hampshire)|(new[ ]jersey)|(new[ ]mexico)|(new[ ]york)|(north[ ]carolina)|(north[ ]dakota)|(ohio)|(oklahoma)|(oregon)|(pennsylvania)|(penn)|(puerto[ ]rico)|(rhode[ ]island)|(south[ ]carolina)|(south[ ]dakota)|(tennessee)|(texas)|(utah)|(vermont)|(virginia)|(virgin[ ]islands)|(wasington)|(west[ ]virginia)|(wisconsin)|(wyoming))

EMAIL	([a-z0-9]("-"|[_+a-z0-9])*)

%%

{EMAIL}"@"{EMAIL}.{EMAIL}	{aflag=P_EMAIL;}
{EMAIL}"!"{EMAIL}		{aflag=P_EMAIL;}


{S}turn/{END}			{aflag=P_DIRECTIONS;}
{S}left/{END}			{aflag=P_DIRECTIONS;}
{S}right/{END}			{aflag=P_DIRECTIONS;}
{S}at[ ]the[ ]light/{END}	{aflag=P_DIRECTIONS;}

[, ]{STATE}/{END}		{aflag=P_ADDRESS | P_STATE;}

{S}north(ern)?/{END}		{aflag=P_ADDRESS | P_NEWS;}
{S}south(ern)?/{END}		{aflag=P_ADDRESS | P_NEWS;}
{S}east(ern)?/{END}		{aflag=P_ADDRESS | P_NEWS;}
{S}west(ern)?/{END}		{aflag=P_ADDRESS | P_NEWS;}
{S}central/{END}		{aflag=P_ADDRESS | P_NEWS;}

{S}alley/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}ally{P}			{aflag=P_ADDRESS | P_STREET;}
{S}arcade/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}arc{P}			{aflag=P_ADDRESS | P_STREET;}
{S}avenue/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}ave{P}			{aflag=P_ADDRESS | P_STREET;}
{S}apartment/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}apt{P}			{aflag=P_ADDRESS | P_STREET;}
{S}boulevard/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}blvd{P}			{aflag=P_ADDRESS | P_STREET;}
{S}branch/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}br{P}			{aflag=P_ADDRESS | P_STREET;}
{S}bypass/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}byp{P}			{aflag=P_ADDRESS | P_STREET;}
{S}causeway/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}cswy{P}			{aflag=P_ADDRESS | P_STREET;}
{S}center/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}ctr{P}			{aflag=P_ADDRESS | P_STREET;}
{S}circle/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}cir{P}			{aflag=P_ADDRESS | P_STREET;}
{S}court/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}ct{P}			{aflag=P_ADDRESS | P_STREET;}
{S}courts/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}cts{P}			{aflag=P_ADDRESS | P_STREET;}
{S}crescent/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}cres{P}			{aflag=P_ADDRESS | P_STREET;}
{S}drive/{END}			{aflag=P_ADDRESS | P_STREET;}
{W}dr{P}			{aflag=P_ADDRESS | P_STREET;}
{S}expressway/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}expy{P}			{aflag=P_ADDRESS | P_STREET;}
{S}extended/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}extension/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}freeway/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}fwy{P}			{aflag=P_ADDRESS | P_STREET;}
{S}gardens/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}gdns{P}			{aflag=P_ADDRESS | P_STREET;}
{S}grove/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}grv{P}			{aflag=P_ADDRESS | P_STREET;}
{S}heights/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}hts{P}			{aflag=P_ADDRESS | P_STREET;}
{S}highway/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}hwy{P}			{aflag=P_ADDRESS | P_STREET;}
{S}lane/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}ln{P}			{aflag=P_ADDRESS | P_STREET;}
{S}manner/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}mnr{P}			{aflag=P_ADDRESS | P_STREET;}
{S}place/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}pl{P}			{aflag=P_ADDRESS | P_STREET;}
{S}plaza/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}plz{P}			{aflag=P_ADDRESS | P_STREET;}
{S}point/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}pt{P}			{aflag=P_ADDRESS | P_STREET;}
{S}road/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}rd{P}			{aflag=P_ADDRESS | P_STREET;}
{S}rural/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}square/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}sq{P}			{aflag=P_ADDRESS | P_STREET;}
{S}street/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}st{P}			{aflag=P_ADDRESS | P_STREET;}
{S}terrace/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}terr?{P}			{aflag=P_ADDRESS | P_STREET;}
{S}trail/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}trl{P}			{aflag=P_ADDRESS | P_STREET;}
{S}turnpike/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}tpke?{P}			{aflag=P_ADDRESS | P_STREET;}
{S}viaduct/{END}		{aflag=P_ADDRESS | P_STREET;}
{S}via{P}			{aflag=P_ADDRESS | P_STREET;}
{S}vista/{END}			{aflag=P_ADDRESS | P_STREET;}
{S}vis{P}			{aflag=P_ADDRESS | P_STREET;}

{S}administration/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}admin{P}			{aflag=P_ADDRESS | P_ORG;}
{S}beach/{END}			{aflag=P_ADDRESS | P_ORG;}
{S}bldg/{END}			{aflag=P_ADDRESS | P_ORG;}
{S}building/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}bureau/{END}			{aflag=P_ADDRESS | P_ORG;}
{S}college/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}corporation/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}commission/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}conference/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}corp{P}			{aflag=P_ADDRESS | P_ORG;}
{S}federal/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}foundation/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}project/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}institute/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}office/{END}			{aflag=P_ADDRESS | P_ORG | P_OFFICE;}
{S}school/{END}			{aflag=P_ADDRESS | P_ORG | P_OFFICE;}
{S}preschool/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}society/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}suite/{END}			{aflag=P_ADDRESS | P_ORG;}
{S}university/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}alliance/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}coalition/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}house/{END}			{aflag=P_ADDRESS | P_ORG;}
{S}consulate/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}embassy/{END}		{aflag=P_ADDRESS | P_ORG;}
{S}univ{P}			{aflag=P_ADDRESS | P_ORG;}

{S}AMERICANA?/{END}		{aflag = P_ADDRESS | P_ORG; }
{S}CANADIAN/{END}		{aflag = P_ADDRESS | P_ORG; }
{S}ENGLISH/{END}		{aflag = P_ADDRESS | P_ORG; }
{S}GERMAN/{END}			{aflag = P_ADDRESS | P_ORG; }
{S}DUTCH/{END}			{aflag = P_ADDRESS | P_ORG; }
{S}SPANISH/{END}		{aflag = P_ADDRESS | P_ORG; }
{S}FRENCH/{END}			{aflag = P_ADDRESS | P_ORG; }
{S}CHINESE/{END}		{aflag = P_ADDRESS | P_ORG; }
{S}JAPANESE/{END}		{aflag = P_ADDRESS | P_ORG; }
{S}ISRAELI/{END}		{aflag = P_ADDRESS | P_ORG; }

{S}City/{END}			{aflag=P_ADDRESS | P_CITY;}
{S}harvard/{END}		{aflag=P_ADDRESS | P_CITY;}
{S}MIT/{END}			{aflag=P_ADDRESS | P_CITY;}

{S}america/{END}		{aflag=P_ADDRESS;}
{S}pacific/{END}		{aflag=P_ADDRESS;}
{S}atlantic/{END}		{aflag=P_ADDRESS;}

{S}afghanistan/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}africa/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}albania/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}algeria/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}andorra/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}angola/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}argentina/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}ascension/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}australia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}austria/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}azores/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}bahamas/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}bahrain/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}bangladesh/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}barbados/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}belfast/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}belgium/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}belize/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}benin/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}bermuda/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}bhutan/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}bolivia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}botswana/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}brazil/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}brunei/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}bulgaria/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}burma/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}burundi/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}cambodia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}cameroon/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}canada/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}cape[ ]verde/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}cayman[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}centeral[ ]african[ ]republic/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}chad/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}chile/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}china/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}columbia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}colombia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}comoros/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}congo/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}corsica/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}costa[ ]rica/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}cuba/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}cyprus/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}czechoslovakia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}denmark/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}derbys/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}djibouti/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}dominica/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}dominican[ ]republic/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}east[ ]timor/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}ecuador/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}egypt/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}el[ ]salvador/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}equatorial[ ]guinea/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}estonia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}england/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}ethiopia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}faeroe[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}falkland[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}faso/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}fiji/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}finland/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}formosa/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}france/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}french[ ]guiana/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}french[ ]polynesia/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}gabon/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}gambia/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}germany/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}ghana/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}gibraltar/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}great[ ]britain/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}greece/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}greeland/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}grenada/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}guadeloupe/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}guatemala/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}guine/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}guine-bissau/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}guyana/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}gujarat/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}haiti/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}holland/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}honduras/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}hong[ ]kong/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}hungary/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}iceland/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}india/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}indonesia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}iran/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}iraq/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}ireland/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}israel/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}italy/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}ivory[ ]coast/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}jamaica/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}japan/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}jordan/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}kampuchea/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}kenya/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}kiribati/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}korea/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}south[ ]korea/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}north[ ]korea/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}kuwait/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}laos?/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}latvia/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}lebanon/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}leeward[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}lesotho/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}liberia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}libya/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}lithuania/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}luxenborg/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}macao/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}maadagascar/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}madeira[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}malawi/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}malaysia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}maldives/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}mali/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}malta/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}matinique/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}mauritania/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}mauritius/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}mexico/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}mongolia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}mor?rocco/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}mozambique/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}nauru/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}namibia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}nepal/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}netherlands/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}netherlands[ ]antiloes/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}new[ ]caledonia/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}new[ ]guinea/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}new[ ]zealand/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}nicaragua/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}niger/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}nigeria/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}norway/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}oman/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}pakistan/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}panama/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}papua[ ]new[ ]guinea/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}paraguay/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}peru/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}philippines/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}pitcairm[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}poland/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}portugal/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}qatar/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}reunion/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}romania/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}rwanda/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}russia/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}samoa/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}s(ain)?t[. ]+helena/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}s(ain)?t[. ]+lucia/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}s(an)?ta[. ]+lucia/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}s(ain)?t[. ]+pierre/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}s(ain)?t[. ]+thomas/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}s(ain)?t[. ]+vincent/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}santa[ ]cruz[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}saudi[ ]arabia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}scotland/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}senegal/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}seychelles/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}sierre[ ]leone/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}singapore/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}solomon[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}somalia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}south[ ]africa/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}spain/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}sri[ ]lanka/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}sudan/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}suriname/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}swaziland/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}sweden/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}switzerland/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}syria/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}taiwan/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}tanzania/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}tasmania/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}thailand/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}the[ ]+netherlands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}togo/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}tonga/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}trinidad/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}tristan[ ]da[ ]cunha/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}tunisia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}turkey/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}turks[ ]and[ ]caicos[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}tuvalu/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}ellice[ ]islands/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}uganda/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}u[. ]*s[. ]*s[. ]*r[. ]*/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}united[ ]arab[ ]emirates/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}upper[ ]volta/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}uruguay/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}united[ ]kingdom/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}vanuatu/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}vatican/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}venezuela/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}vietnam/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}western[ ]samoa/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}western[ ]sahara/{END}	{aflag=P_ADDRESS | P_COUNTRY;}
{S}yemen/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}yugoslavia/{END}		{aflag=P_ADDRESS | P_COUNTRY;}
{S}zaire/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}zambia/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}zimbabwe/{END}		{aflag=P_ADDRESS | P_COUNTRY;}

{S}paris/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}london/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}madrid/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}genova/{END}			{aflag=P_ADDRESS | P_COUNTRY;}
{S}brondby/{END}		{aflag=P_ADDRESS | P_COUNTRY;}

{S}JEWISH/{END}			{aflag = P_ADDRESS;}
{S}CATHOLIC/{END}		{aflag = P_ADDRESS;}
{S}CHRISTIAN/{END}		{aflag = P_ADDRESS;}

{S}Abilene('S)?/{END}		{aflag = P_ADDRESS;}
{S}Aiken('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Akron('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Albany('S)?/{END}		{aflag = P_ADDRESS;}
{S}Albuquerque('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Alexandria('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Allentown('S)?/{END}		{aflag = P_ADDRESS;}
{S}Altoona('S)?/{END}		{aflag = P_ADDRESS;}
{S}Amarillo('S)?/{END}		{aflag = P_ADDRESS;}
{S}Anchorage('S)?/{END}		{aflag = P_ADDRESS;}
{S}Anderson('S)?/{END}		{aflag = P_ADDRESS;}
{S}Ann" "Arbor('S)?/{END}	{aflag = P_ADDRESS;}
{S}Anniston('S)?/{END}		{aflag = P_ADDRESS;}
{S}Appleton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Arlington('S)?/{END}		{aflag = P_ADDRESS;}
{S}Asheville('S)?/{END}		{aflag = P_ADDRESS;}
{S}Ashland('S)?/{END}		{aflag = P_ADDRESS;}
{S}Atascadero('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Athens('S)?/{END}		{aflag = P_ADDRESS;}
{S}Atlanta('S)?/{END}		{aflag = P_ADDRESS;}
{S}Atlantic('S)?/{END}		{aflag = P_ADDRESS;}
{S}Auburn('S)?/{END}		{aflag = P_ADDRESS;}
{S}Augusta('S)?/{END}		{aflag = P_ADDRESS;}
{S}Austin('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bakersfield('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Baltimore('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bangor('S)?/{END}		{aflag = P_ADDRESS;}
{S}Barnstable('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Baton" "Rouge('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Battle" "Creek('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Bay" "City('S)?/{END}		{aflag = P_ADDRESS;}
{S}Beaumont('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bellevue('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bellingham('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Beloit('S)?/{END}		{aflag = P_ADDRESS;}
{S}Benton" "Harbor('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Bergen('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bethlehem('S)?/{END}		{aflag = P_ADDRESS;}
{S}Billings('S)?/{END}		{aflag = P_ADDRESS;}
{S}Biloxi('S)?/{END}		{aflag = P_ADDRESS;}
{S}Binghamton('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Birmingham('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Bismarck('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bloomington('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Boca" "Raton('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Boise" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Bossier" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Boston('S)?/{END}		{aflag = P_ADDRESS;}
{S}Boulder('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bradenton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Brazoria('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bremerton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bridgeport('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Bridgeton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Bristol('S)?/{END}		{aflag = P_ADDRESS;}
{S}Brockton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Brownsville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Bryan('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Buffalo('S)?/{END}		{aflag = P_ADDRESS;}
{S}Burlington('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Canton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Cape" "Coral('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Cape" "May('S)?/{END}		{aflag = P_ADDRESS;}
{S}Carlisle('S)?/{END}		{aflag = P_ADDRESS;}
{S}Casper('S)?/{END}		{aflag = P_ADDRESS;}
{S}Cedar" "Falls('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Cedar" "Rapids('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Champaign('S)?/{END}		{aflag = P_ADDRESS;}
{S}Chapel" "Hill('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Charleston('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Charlotte('S)?/{END}		{aflag = P_ADDRESS;}
{S}Charlottesville('S)?/{END}		{aflag = P_ADDRESS;}
{S}Chattanooga('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Cheyenne('S)?/{END}		{aflag = P_ADDRESS;}
{S}Chicago('S)?/{END}		{aflag = P_ADDRESS;}
{S}Chico('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Cincinnati('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Clarksville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Clearwater('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Cleveland('S)?/{END}		{aflag = P_ADDRESS;}
{S}College" "Station('S)?/{END}		{aflag = P_ADDRESS;}
{S}Colorado" "Springs('S)?/{END}		{aflag = P_ADDRESS;}
{S}Columbia('S)?/{END}		{aflag = P_ADDRESS;}
{S}Columbus('S)?/{END}		{aflag = P_ADDRESS;}
{S}Corpus" "Christi('S)?/{END}		{aflag = P_ADDRESS;}
{S}Cumberland('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Dallas('S)?/{END}		{aflag = P_ADDRESS;}
{S}Danbury('S)?/{END}		{aflag = P_ADDRESS;}
{S}Danville('S)?/{END}		{aflag = P_ADDRESS;}
{S}Davenport('S)?/{END}		{aflag = P_ADDRESS;}
{S}Dayton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Daytona" "Beach('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Decatur('S)?/{END}		{aflag = P_ADDRESS;}
{S}Denison('S)?/{END}		{aflag = P_ADDRESS;}
{S}Denver('S)?/{END}		{aflag = P_ADDRESS;}
{S}Des" "Moines('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Detroit('S)?/{END}		{aflag = P_ADDRESS;}
{S}Dothan('S)?/{END}		{aflag = P_ADDRESS;}
{S}Dover('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Dubuque('S)?/{END}		{aflag = P_ADDRESS;}
{S}Duluth('S)?/{END}		{aflag = P_ADDRESS;}
{S}Durham('S)?/{END}		{aflag = P_ADDRESS;}
{S}Dutchess" "County('S)?/{END}		{aflag = P_ADDRESS;}
{S}East" "Lansing('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Easton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Eau" "Claire('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Edinburg('S)?/{END}		{aflag = P_ADDRESS;}
{S}El" "Paso('S)?/{END}		{aflag = P_ADDRESS;}
{S}Elkhart('S)?/{END}		{aflag = P_ADDRESS;}
{S}Elmira('S)?/{END}		{aflag = P_ADDRESS;}
{S}Elyria('S)?/{END}		{aflag = P_ADDRESS;}
{S}Enid('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Erie('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Eugene('S)?/{END}		{aflag = P_ADDRESS;}
{S}Evansville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Everett('S)?/{END}		{aflag = P_ADDRESS;}
{S}Fairfield('S)?/{END}		{aflag = P_ADDRESS;}
{S}Fall" "River('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Fargo('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Fayetteville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Fitchburg('S)?/{END}		{aflag = P_ADDRESS;}
{S}Flagstaff('S)?/{END}		{aflag = P_ADDRESS;}
{S}Flint('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Florence('S)?/{END}		{aflag = P_ADDRESS;}
{S}Fort" "Collins('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Fort" "Lauderdale('S)?/{END}		{aflag = P_ADDRESS;}
{S}Fort" "Myers('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Fort" "Pierce('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Fort" "Smith('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Fort" "Walton" "Beach('S)?/{END}		{aflag = P_ADDRESS;}
{S}Fort" "Wayne('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Fort" "Worth('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Fresno('S)?/{END}		{aflag = P_ADDRESS;}
{S}Gadsden('S)?/{END}		{aflag = P_ADDRESS;}
{S}Gainesville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Galveston('S)?/{END}		{aflag = P_ADDRESS;}
{S}Gary('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Gastonia('S)?/{END}		{aflag = P_ADDRESS;}
{S}Glens" "Falls('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Goldsboro('S)?/{END}		{aflag = P_ADDRESS;}
{S}Goshen('S)?/{END}		{aflag = P_ADDRESS;}
{S}Grand" "Forks('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Grand" "Junction('S)?/{END}		{aflag = P_ADDRESS;}
{S}Grand" "Rapids('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Great" "Falls('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Greeley('S)?/{END}		{aflag = P_ADDRESS;}
{S}Green" "Bay('S)?/{END}		{aflag = P_ADDRESS;}
{S}Greensboro('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Greenville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Gulfport('S)?/{END}		{aflag = P_ADDRESS;}
{S}Hagerstown('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Hamilton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Harlingen('S)?/{END}		{aflag = P_ADDRESS;}
{S}Harrisburg('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Hartford('S)?/{END}		{aflag = P_ADDRESS;}
{S}Hattiesburg('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Hazleton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Henderson('S)?/{END}		{aflag = P_ADDRESS;}
{S}Hickory('S)?/{END}		{aflag = P_ADDRESS;}
{S}High" "Point('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Holland('S)?/{END}		{aflag = P_ADDRESS;}
{S}Honolulu('S)?/{END}		{aflag = P_ADDRESS;}
{S}Hopkinsville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Houma('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Houston('S)?/{END}		{aflag = P_ADDRESS;}
{S}Hunterdon('S)?/{END}		{aflag = P_ADDRESS;}
{S}Huntington('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Huntsville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Indianapolis('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Iowa" "City('S)?/{END}		{aflag = P_ADDRESS;}
{S}Jackson('S)?/{END}		{aflag = P_ADDRESS;}
{S}Jacksonville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Jamestown('S)?/{END}		{aflag = P_ADDRESS;}
{S}Janesville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Jersey" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Johnson" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Johnstown('S)?/{END}		{aflag = P_ADDRESS;}
{S}Jonesboro('S)?/{END}		{aflag = P_ADDRESS;}
{S}Joplin('S)?/{END}		{aflag = P_ADDRESS;}
{S}Kalamazoo('S)?/{END}		{aflag = P_ADDRESS;}
{S}Kankakee('S)?/{END}		{aflag = P_ADDRESS;}
{S}Kansas" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Kennewick('S)?/{END}		{aflag = P_ADDRESS;}
{S}Kenosha('S)?/{END}		{aflag = P_ADDRESS;}
{S}Killeen('S)?/{END}		{aflag = P_ADDRESS;}
{S}Kingsport('S)?/{END}		{aflag = P_ADDRESS;}
{S}Knoxville('S)?/{END}		{aflag = P_ADDRESS;}
{S}Kokomo('S)?/{END}		{aflag = P_ADDRESS;}
{S}La" "Crosse('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lafayette('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lake" "Charles('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Lakeland('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lancaster('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lansing('S)?/{END}		{aflag = P_ADDRESS;}
{S}Laredo('S)?/{END}		{aflag = P_ADDRESS;}
{S}Las" "Cruces('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Las" "Vegas('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lawrence('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lawton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lebanon('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lenoir('S)?/{END}		{aflag = P_ADDRESS;}
{S}Leominster('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Lewiston('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lexington('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lima('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Lincoln('S)?/{END}		{aflag = P_ADDRESS;}
{S}Little" "Rock('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Lodi('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Lompoc('S)?/{END}		{aflag = P_ADDRESS;}
{S}Long" "Beach('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Longmont('S)?/{END}		{aflag = P_ADDRESS;}
{S}Longview('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lorain('S)?/{END}		{aflag = P_ADDRESS;}
{S}Los" "Angeles('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Louisville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Loveland('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lowell('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lubbock('S)?/{END}		{aflag = P_ADDRESS;}
{S}Lynchburg('S)?/{END}		{aflag = P_ADDRESS;}
{S}Macon('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Madison('S)?/{END}		{aflag = P_ADDRESS;}
{S}Manchester('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Mansfield('S)?/{END}		{aflag = P_ADDRESS;}
{S}Marietta('S)?/{END}		{aflag = P_ADDRESS;}
{S}Marshall('S)?/{END}		{aflag = P_ADDRESS;}
{S}Massillon('S)?/{END}		{aflag = P_ADDRESS;}
{S}Mcallen('S)?/{END}		{aflag = P_ADDRESS;}
{S}Medford('S)?/{END}		{aflag = P_ADDRESS;}
{S}Melbourne('S)?/{END}		{aflag = P_ADDRESS;}
{S}Memphis('S)?/{END}		{aflag = P_ADDRESS;}
{S}Merced('S)?/{END}		{aflag = P_ADDRESS;}
{S}Meriden('S)?/{END}		{aflag = P_ADDRESS;}
{S}Mesa('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Miami('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Middlesex('S)?/{END}		{aflag = P_ADDRESS;}
{S}Middletown('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Midland('S)?/{END}		{aflag = P_ADDRESS;}
{S}Millville('S)?/{END}		{aflag = P_ADDRESS;}
{S}Milwaukee('S)?/{END}		{aflag = P_ADDRESS;}
{S}Minneapolis('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Mission('S)?/{END}		{aflag = P_ADDRESS;}
{S}Missoula('S)?/{END}		{aflag = P_ADDRESS;}
{S}Mobile('S)?/{END}		{aflag = P_ADDRESS;}
{S}Modesto('S)?/{END}		{aflag = P_ADDRESS;}
{S}Moline('S)?/{END}		{aflag = P_ADDRESS;}
{S}Monmouth('S)?/{END}		{aflag = P_ADDRESS;}
{S}Monroe('S)?/{END}		{aflag = P_ADDRESS;}
{S}Montgomery('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Moorhead('S)?/{END}		{aflag = P_ADDRESS;}
{S}Morganton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Muncie('S)?/{END}		{aflag = P_ADDRESS;}
{S}Muskegon('S)?/{END}		{aflag = P_ADDRESS;}
{S}Myrtle" "Beach('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Napa('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Naples('S)?/{END}		{aflag = P_ADDRESS;}
{S}Nashua('S)?/{END}		{aflag = P_ADDRESS;}
{S}Nashville('S)?/{END}		{aflag = P_ADDRESS;}
{S}Nassau('S)?/{END}		{aflag = P_ADDRESS;}
{S}Neenah('S)?/{END}		{aflag = P_ADDRESS;}
{S}New" "Bedford('S)?/{END}	    {aflag = P_ADDRESS;}
{S}New" "Haven('S)?/{END}		{aflag = P_ADDRESS;}
{S}New" "London('S)?/{END}	    {aflag = P_ADDRESS;}
{S}New" "Orleans('S)?/{END}	    {aflag = P_ADDRESS;}
{S}New" "York('S)?/{END}		{aflag = P_ADDRESS;}
{S}Newark('S)?/{END}		{aflag = P_ADDRESS;}
{S}Newburgh('S)?/{END}		{aflag = P_ADDRESS;}
{S}Newport" "News('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Niagara" "Falls('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Norfolk('S)?/{END}		{aflag = P_ADDRESS;}
{S}Normal('S)?/{END}		{aflag = P_ADDRESS;}
{S}North" "Charleston('S)?/{END}		{aflag = P_ADDRESS;}
{S}North" "Little" "Rock('S)?/{END}		{aflag = P_ADDRESS;}
{S}Norwalk('S)?/{END}		{aflag = P_ADDRESS;}
{S}Norwich('S)?/{END}		{aflag = P_ADDRESS;}
{S}Oakland('S)?/{END}		{aflag = P_ADDRESS;}
{S}Ocala('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Ocean('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Odessa('S)?/{END}		{aflag = P_ADDRESS;}
{S}Ogden('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Oklahoma" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Olympia('S)?/{END}		{aflag = P_ADDRESS;}
{S}Omaha('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Orange" "County('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Orem('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Orlando('S)?/{END}		{aflag = P_ADDRESS;}
{S}Oshkosh('S)?/{END}		{aflag = P_ADDRESS;}
{S}Owensboro('S)?/{END}		{aflag = P_ADDRESS;}
{S}Palm" "Bay('S)?/{END}		{aflag = P_ADDRESS;}
{S}Panama" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Paradise('S)?/{END}		{aflag = P_ADDRESS;}
{S}Parkersburg('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Pascagoula('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Pasco('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Paso" "Robles('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Passaic('S)?/{END}		{aflag = P_ADDRESS;}
{S}Pekin('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Pensacola('S)?/{END}		{aflag = P_ADDRESS;}
{S}Peoria('S)?/{END}		{aflag = P_ADDRESS;}
{S}Petersburg('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Philadelphia('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Phoenix('S)?/{END}		{aflag = P_ADDRESS;}
{S}Pine" "Bluff('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Pittsburgh('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Pittsfield('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Pocatello('S)?/{END}		{aflag = P_ADDRESS;}
{S}Port" "Arthur('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Port" "St." "Lucie('S)?/{END}		{aflag = P_ADDRESS;}
{S}Porterville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Portland('S)?/{END}		{aflag = P_ADDRESS;}
{S}Portsmouth('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Providence('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Provo('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Pueblo('S)?/{END}		{aflag = P_ADDRESS;}
{S}Punta" "Gorda('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Racine('S)?/{END}		{aflag = P_ADDRESS;}
{S}Raleigh('S)?/{END}		{aflag = P_ADDRESS;}
{S}Rapid" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Reading('S)?/{END}		{aflag = P_ADDRESS;}
{S}Redding('S)?/{END}		{aflag = P_ADDRESS;}
{S}Reno('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Richland('S)?/{END}		{aflag = P_ADDRESS;}
{S}Richmond('S)?/{END}		{aflag = P_ADDRESS;}
{S}Riverside('S)?/{END}		{aflag = P_ADDRESS;}
{S}Roanoke('S)?/{END}		{aflag = P_ADDRESS;}
{S}Rochester('S)?/{END}		{aflag = P_ADDRESS;}
{S}Rock" "Hill('S)?/{END}		{aflag = P_ADDRESS;}
{S}Rock" "Island('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Rockford('S)?/{END}		{aflag = P_ADDRESS;}
{S}Rocky" "Mount('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Rogers('S)?/{END}		{aflag = P_ADDRESS;}
{S}Rome('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Sacramento('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Saginaw('S)?/{END}		{aflag = P_ADDRESS;}
{S}Salem('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Salinas('S)?/{END}		{aflag = P_ADDRESS;}
{S}Salt" "Lake" "City('S)?/{END}		{aflag = P_ADDRESS;}
{S}San" "Angelo('S)?/{END}	    {aflag = P_ADDRESS;}
{S}San" "Antonio('S)?/{END}	    {aflag = P_ADDRESS;}
{S}San" "Benito('S)?/{END}	    {aflag = P_ADDRESS;}
{S}San" "Bernardino('S)?/{END}		{aflag = P_ADDRESS;}
{S}San" "Diego('S)?/{END}		{aflag = P_ADDRESS;}
{S}San" "Francisco('S)?/{END}	    {aflag = P_ADDRESS;}
{S}San" "Jose('S)?/{END}		{aflag = P_ADDRESS;}
{S}San" "Luis" "Obispo('S)?/{END}		{aflag = P_ADDRESS;}
{S}San" "Marcos('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Santa" "Barbara('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Santa" "Cruz('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Santa" "Fe('S)?/{END}		{aflag = P_ADDRESS;}
{S}Santa" "Maria('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Santa" "Rosa('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Sarasota('S)?/{END}		{aflag = P_ADDRESS;}
{S}Savannah('S)?/{END}		{aflag = P_ADDRESS;}
{S}Schenectady('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Scranton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Seattle('S)?/{END}		{aflag = P_ADDRESS;}
{S}Sharon('S)?/{END}		{aflag = P_ADDRESS;}
{S}Sheboygan('S)?/{END}		{aflag = P_ADDRESS;}
{S}Sherman('S)?/{END}		{aflag = P_ADDRESS;}
{S}Shreveport('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Sioux" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Sioux" "Falls('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Somerset('S)?/{END}		{aflag = P_ADDRESS;}
{S}South" "Bend('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Spartanburg('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Spokane('S)?/{END}		{aflag = P_ADDRESS;}
{S}Springdale('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Springfield('S)?/{END}	    {aflag = P_ADDRESS;}
{S}St." "Cloud('S)?/{END}		{aflag = P_ADDRESS;}
{S}St." "Joseph('S)?/{END}	    {aflag = P_ADDRESS;}
{S}St." "Louis('S)?/{END}		{aflag = P_ADDRESS;}
{S}St." "Paul('S)?/{END}		{aflag = P_ADDRESS;}
{S}St." "Petersburg('S)?/{END}		{aflag = P_ADDRESS;}
{S}Stamford('S)?/{END}		{aflag = P_ADDRESS;}
{S}State" "College('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Steubenville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Stockton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Suffolk('S)?/{END}		{aflag = P_ADDRESS;}
{S}Sumter('S)?/{END}		{aflag = P_ADDRESS;}
{S}Superior('S)?/{END}		{aflag = P_ADDRESS;}
{S}Syracuse('S)?/{END}		{aflag = P_ADDRESS;}
{S}Tacoma('S)?/{END}		{aflag = P_ADDRESS;}
{S}Tallahassee('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Tampa('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Temple('S)?/{END}		{aflag = P_ADDRESS;}
{S}Terre" "Haute('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Texarkana('S)?/{END}		{aflag = P_ADDRESS;}
{S}Texas" "City('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Titusville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Toledo('S)?/{END}		{aflag = P_ADDRESS;}
{S}Topeka('S)?/{END}		{aflag = P_ADDRESS;}
{S}Trenton('S)?/{END}		{aflag = P_ADDRESS;}
{S}Troy('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Tucson('S)?/{END}		{aflag = P_ADDRESS;}
{S}Tulare('S)?/{END}		{aflag = P_ADDRESS;}
{S}Tulsa('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Tuscaloosa('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Tyler('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Urbana('S)?/{END}		{aflag = P_ADDRESS;}
{S}Utica('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Vallejo('S)?/{END}		{aflag = P_ADDRESS;}
{S}Vancouver('S)?/{END}		{aflag = P_ADDRESS;}
{S}Ventura('S)?/{END}		{aflag = P_ADDRESS;}
{S}Victoria('S)?/{END}		{aflag = P_ADDRESS;}
{S}Vineland('S)?/{END}		{aflag = P_ADDRESS;}
{S}Virginia" "Beach('S)?/{END}		{aflag = P_ADDRESS;}
{S}Visalia('S)?/{END}		{aflag = P_ADDRESS;}
{S}Waco('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Warren('S)?/{END}		{aflag = P_ADDRESS;}
{S}Warwick('S)?/{END}		{aflag = P_ADDRESS;}
{S}Washington('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Waterbury('S)?/{END}		{aflag = P_ADDRESS;}
{S}Waterloo('S)?/{END}		{aflag = P_ADDRESS;}
{S}Watsonville('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Waukesha('S)?/{END}		{aflag = P_ADDRESS;}
{S}Wausau('S)?/{END}		{aflag = P_ADDRESS;}
{S}Weirton('S)?/{END}		{aflag = P_ADDRESS;}
{S}West" "Palm" "Beach('S)?/{END}		{aflag = P_ADDRESS;}
{S}Wheeling('S)?/{END}		{aflag = P_ADDRESS;}
{S}Wichita('S)?/{END}		{aflag = P_ADDRESS;}
{S}Wichita" "Falls('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Wilkes-Barre('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Williamsport('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Wilmington('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Winston('S)?/{END}		{aflag = P_ADDRESS;}
{S}Winter" "Haven('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Worcester('S)?/{END}		{aflag = P_ADDRESS;}
{S}Yakima('S)?/{END}		{aflag = P_ADDRESS;}
{S}Yarmouth('S)?/{END}		{aflag = P_ADDRESS;}
{S}Yolo('S)?/{END}	    {aflag = P_ADDRESS;}
{S}York('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Youngstown('S)?/{END}	    {aflag = P_ADDRESS;}
{S}Yuba" "City('S)?/{END}		{aflag = P_ADDRESS;}
{S}Yuma('S)?/{END}	    {aflag = P_ADDRESS;}


{S}att(entio)?n[.]?[:][ ]	{aflag = P_ADDRESS;}		/* 3-29-94 */

\001[ ]*[0-9]{5}[ ]*\032 			{aflag=P_ADDRESS | P_ZIP;}
\001[ ]*[0-9]{5}-[0-9]{4}[ ]*\032 		{aflag=P_ADDRESS | P_ZIP;}

\001[ ]*([-()0-9 ,./*])+[0-9]{4,}[ ]*\032	{aflag=P_TELEPHONE;}
\001[ ]*[(]?"+"[)]?[0-9]+"-"[0-9]+[- '.][0-9]+	{aflag=P_TELEPHONE;} /* 3-29-94 */
\001[ ]*[(]?"+"[)]?([0-9][0-9][- '.]){4,6}	{aflag=P_TELEPHONE;} /* 3-29-94 */
\001[ ]*"+"[0-9][0-9][- '][0-9][0-9][0-9][- '][0-9][0-9][0-9]	{aflag=P_TELEPHONE;} /* 3-29-94 */
([0-9][0-9][ ']){4}	{aflag=P_TELEPHONE;} /* 3-29-94 */

%%


int	parse_address(const char *buf)
{
	char	*mbuf	= (char*)alloca(strlen(buf)+16);
	char	*cc;
	const	char *dd;

	if(0)	yyunput(0,0);

	cc	= mbuf;
	*cc++	= 1;			/* begin with control-a */
	*cc++	= ' ';			/* Put in a space */
	for(dd=buf;*dd;dd++,cc++){	/* Copy the data, just the low bits */
		*cc = (*dd & 0x7f);
		if(*cc == '\t') *cc = ' ';  /* Turn tabs to spaces */
	}
	*cc++	= ' ';			/* Put three spaces at the end */
	*cc++	= ' ';
	*cc++	= ' ';
	*cc++	= 26;			/* end with a control-z */
	*cc++	= EOF;			/* Put in the EOF character */
	*cc++	= '\000';

	lptr	= mbuf;
	aflag	= 0;			/* what we found */


	/* initialize flex static variables */
	yy_init			= 1;		/* be sure to init */
	yy_current_buffer	= 0;
	yy_c_buf_p 		= 0;
	yy_start		= 0;
	yyin			= 0;
	yyout			= 0;
	Yeof			= 0;

	yylex();		/* Do it! */

	yy_delete_buffer(yy_current_buffer); // - do we need to do this?
	yy_current_buffer	= 0;

	return aflag;
}



