%{
//
//	Copyright (C) 1991, 1992, 2000 Simson L. Garfinkel
//	All rights reserved.
//
//

#include "libsbook.h"
#include "flexhdr.h"

static	int	aflag;
			
%}

S	[ ]
END	[^a-zA-Z]
P	[., ]
ZIP	[0-9]{5}((-[0-9]{4})?)
STATE_ABBREV	((AL)|(AK)|(AS)|(AZ)|(AR)|(BC)|(CA)|(CZ)|(CO)|(CT)|(DE)|(DC)|(FL)|(GA)|(GU)|(HI)|(ID)|(IL)|(IN)|(IA)|(KS)|(KY)|(LA)|(ME)|(MD)|(MA)|(MI)|(MN)|(MS)|(MO)|(MT)|(NE)|(NB)|(NH)|(NJ)|(NM)|(NV)|(NY)|(NC)|(ND)|(CM)|(OH)|(OK)|(OR)|(OT)|(PA)|(PR)|(RI)|(SC)|(SD)|(TN)|(TX)|(TT)|(UT)|(VT)|(VA)|(VI)|(WA)|(WV)|(WI)|(WY))
%%

{S}[A-Z][A-Za-z]+,?[ ]+{STATE_ABBREV}/{END}	{aflag=P_ADDRESS|P_STATE;}


%%



int	parse_case(const char *buf)
{
	char	*mbuf	= (char*)alloca(strlen(buf)+16);
	char	*cc;
	const	char *dd;

	if(0)	yyunput(0,0);

	cc	= mbuf;
	*cc++	= ' ';
	for(dd=buf;*dd;dd++,cc++){
		*cc = (*dd & 0x7f);
		if(*cc == '\t') *cc = ' ';
	}
	*cc++	= ' ';
	*cc++	= ' ';
	*cc++	= ' ';
	*cc++	= EOF;
	*cc++	= '\000';
	
	lptr	= mbuf;
	aflag	= 0;


	/* initialize flex static variables */
	yy_init			= 1;		/* be sure to init */
	yy_current_buffer	= 0;
	yy_c_buf_p 		= 0;
	yy_start		= 0;
	yyin			= 0;
	yyout			= 0;
	Yeof			= 0;

	
	yylex();		/* DO IT! */

	yy_delete_buffer(yy_current_buffer);
	yy_current_buffer	= 0;

	return aflag;
}
