%{
//
//	Copyright (C) 1993, 1994 Sarrus Software, Inc.
//	All rights reserved.
//	$Id: parse_company.flex,v 1.8 2001/06/25 05:57:31 simsong Exp $
//
//	Company parser built out of flex.
//	Return TRUE if the name provided is probably a company...
//

#include "libsbook.h"
#include "flexhdr.h"

static	int	aflag;
			
%}

S	[^A-Z]
END	[^A-Z]

%%

\001[ ]*[A-Z]+"'S "[A-Z]+[ ]*\032	{aflag = 1;}
{S}[A-Z]+"/"[A-Z]+{S}		{aflag = 1;}
{S}for{S}			{aflag = 1;}
{S}[A-Z]-[A-Z]*[ ]		{aflag = 1;}
{S}U"."?[ ]*S"."?[ ]+		{aflag = 1;}

[A-Z]\*[A-Z]			{aflag = 1;}


"&"				{aflag = 1;}

\.COM/{END}			{aflag = 1;}
\.NET/{END}			{aflag = 1;}
\.ORG/{END}			{aflag = 1;}
\.MIL/{END}			{aflag = 1;}
\.EDU/{END}			{aflag = 1;}
\.INT/{END}			{aflag = 1;}

{S}[WK][A-Z][A-Z][A-Z]?" "(9[0-9]\.[0-9])|(10[0-9]\.[0-9])|([5-9][0-9]0)|(1[0-7][0-9]0)	{aflag=1;}

[A-Z]*STAIRS/{END}		{aflag = 1;}
[A-Z]WARE/{END}			{aflag = 1;}
[A-Z]-?tech/{END}		{aflag = 1;}
[A-Z]-tel/{END}			{aflag = 1;}
[A-Z]data/{END}			{aflag = 1;}
{S}"power and light"/{END}	{aflag = 1;}
{S}"grateful dead"/{END}	{aflag = 1;}
{S}"hewlett packard"/{END}	{aflag = 1;}

{S}"BLUE CROSS"/{END}		{aflag = 1;}
{S}"BLUE SHIELD"/{END}		{aflag = 1;}
{S}ACCESS/{END}			{aflag = 1;}
{S}ACCESSORIES?/{END}		{aflag = 1;}
{S}ACCOMMODATIONS?/{END}	{aflag = 1;}
{S}ACLU/{END}			{aflag = 1;}
{S}ACME/{END}			{aflag = 1;}
{S}ACTION/{END}			{aflag = 1;}
{S}ACTIVATION/{END}		{aflag = 1;}
{S}ACTIVE/{END}			{aflag = 1;}
{S}ADVANCED?/{END}		{aflag = 1;}
{S}AGENCY/{END}			{aflag = 1;}
{S}AIDS/{END}			{aflag = 1;}
{S}AIR				{aflag = 1;}
{S}ALLIED/{END}			{aflag = 1;}
{S}ANIMATION/{END}		{aflag = 1;}
{S}AQUARIUM/{END}		{aflag = 1;}
{S}ARMY/{END}			{aflag = 1;}
{S}ASS/{END}			{aflag = 1;}
{S}ASSOCIATES?/{END}		{aflag = 1;}
{S}ASSOCIATION/{END}		{aflag = 1;}
{S}AUDIO/{END}			{aflag = 1;}
{S}AUTHORIZED/{END}		{aflag = 1;}
{S}AUTO(MOBILE)?S?/{END}	{aflag = 1;}
{S}AVIATION/{END}		{aflag = 1;}
{S}BANK/{END}			{aflag = 1;}
{S}BAY/{END}			{aflag = 1;}
{S}BEFORE/{END}			{aflag = 1;}
{S}BICYCLES?/{END}		{aflag = 1;}
{S}BIKES?/{END}			{aflag = 1;}
{S}BOOKS			{aflag = 1;}
{S}BUGGIES			{aflag = 1;}
{S}CABLE/{END}			{aflag = 1;}
{S}CAFE/{END}			{aflag = 1;}
{S}CAMERA/{END}			{aflag = 1;}
{S}CARGO/{END}			{aflag = 1;}
{S}CASA/{END}			{aflag = 1;}
{S}CATALYTIC/{END}		{aflag = 1;}
{S}CENTER/{END}			{aflag = 1;}
{S}CHEAP/{END}			{aflag = 1;}
{S}CHEMICAL/{END}		{aflag = 1;}
{S}CHEZ/{END}			{aflag = 1;}
{S}CIRCUS/{END}			{aflag = 1;}
{S}CLEANERS?/{END}		{aflag = 1;}
{S}CLUBS?/{END}			{aflag = 1;}
{S}CO/{END}			{aflag = 1;}
{S}COMMITTEE/{END}		{aflag = 1;}
{S}COMMUNICATIONS?/{END}	{aflag = 1;}
{S}COMPANY/{END}		{aflag = 1;}
{S}COMPAQ/{END}			{aflag = 1;}
{S}COMPUTER/{END}		{aflag = 1;}
{S}COMPUTERS/{END}		{aflag = 1;}
{S}COMPUTING/{END}		{aflag = 1;}
{S}CONNECTION/{END}		{aflag = 1;}
{S}CONSULTANTS/{END}		{aflag = 1;}
{S}CONSULTING/{END}		{aflag = 1;}
{S}CONTROL/{END}		{aflag = 1;}
{S}CORP/{END}			{aflag = 1;}
{S}CORPORATION/{END}		{aflag = 1;}
{S}COSTUME/{END}		{aflag = 1;}
{S}CYCLERY/{END}		{aflag = 1;}
{S}DELI/{END}			{aflag = 1;}
{S}DELL/{END}			{aflag = 1;}
{S}DEPENDABLE/{END}		{aflag = 1;}
{S}DESIGN/{END}			{aflag = 1;}
{S}DEVELOPERS?/{END}		{aflag = 1;}
{S}DEVELOPMENT/{END}		{aflag = 1;}
{S}DIGITAL/{END}		{aflag = 1;}
{S}DINER/{END}			{aflag = 1;}
{S}DIR(ECTIONS?)?/{END}		{aflag = 1;}
{S}DRUG(STORE)?/{END}		{aflag = 1;}
{S}ELECTRIC/{END}		{aflag = 1;}
{S}ELECTRONICS/{END}		{aflag = 1;}
{S}ELEVATOR			{aflag = 1;}
{S}ENCHANCEMENTS?/{END}		{aflag = 1;}
{S}ENGINEERING/{END}		{aflag = 1;}
{S}ENTERPRISES/{END}		{aflag = 1;}
{S}EPA/{END}			{aflag = 1;}
{S}EQUIPMENT/{END}		{aflag = 1;}
{S}EXCHANGE/{END}		{aflag = 1;}
{S}EXERCISE/{END}		{aflag = 1;}
{S}EXPRESS/{END}		{aflag = 1;}
{S}FEED(BACK)?/{END}		{aflag = 1;}
{S}FIDELITY/{END}		{aflag = 1;}
{S}FILM/{END}			{aflag = 1;}
{S}FIRE/{END}			{aflag = 1;}
{S}FLY(ING)?/{END}		{aflag = 1;}
{S}FUNERAL/{END}		{aflag = 1;}
{S}FUTURE			{aflag = 1;}
{S}GAS/{END}			{aflag = 1;}
{S}GENERAL/{END}		{aflag = 1;}
{S}GRAPHICS?/{END}		{aflag = 1;}
{S}GRILLE?/{END}		{aflag = 1;}
{S}GROUP/{END}			{aflag = 1;}
{S}GUARD/{END}			{aflag = 1;}
{S}HEALTH			{aflag = 1;}
{S}HEATING/{END}		{aflag = 1;}
{S}HELICOPTER/{END}		{aflag = 1;}
{S}HELP/{END}			{aflag = 1;}
{S}HIGHWAY/{END}		{aflag = 1;}
{S}HILTON/{END}			{aflag = 1;}
{S}HITCHING/{END}		{aflag = 1;}
{S}HOME/{END}			{aflag = 1;}
{S}HONDA/{END}			{aflag = 1;}
{S}HOSPITAL/{END}		{aflag = 1;}
{S}HOTELS?/{END}		{aflag = 1;}
{S}HOTLINE/{END}		{aflag = 1;}
{S}HYATT/{END}			{aflag = 1;}
{S}IBM/{END}			{aflag = 1;}
{S}INCORPORATED/{END}		{aflag = 1;}
{S}INFOR			{aflag = 1;}
{S}INFORMATION/{END}		{aflag = 1;}
{S}INNS?/{END}			{aflag = 1;}
{S}INSURANCE/{END}		{aflag = 1;}
{S}INVESTMENTS?/{END}		{aflag = 1;}
{S}INVESTORS?/{END}		{aflag = 1;}
{S}ISLAMIC/{END}		{aflag = 1;}
{S}ISLAND/{END}			{aflag = 1;}
{S}JEWELERS?/{END}		{aflag = 1;}
{S}JEWISH/{END}			{aflag = 1;}
{S}LAB(ORATORIE)?S?/{END}	{aflag = 1;}
{S}LANDSCAP(E|ING)/{END}	{aflag = 1;}
{S}LASER/{END}			{aflag = 1;}
{S}LAW[ ]OFFICES?/{END}		{aflag = 1;}
{S}LEATHER/{END}		{aflag = 1;}
{S}LIBRARY/{END}		{aflag = 1;}
{S}LIFE/{END}			{aflag = 1;}
{S}LIMITED/{END}		{aflag = 1;}
{S}LLC/{END}			{aflag = 1;}
{S}LNC/{END}			{aflag = 1;}
{S}LOCKSMITHS?/{END}		{aflag = 1;}
{S}LODGE/{END}			{aflag = 1;}
{S}LUGGAGE/{END}		{aflag = 1;}
{S}LUMBER/{END}			{aflag = 1;}
{S}MACHINES?/{END}		{aflag = 1;}
{S}MAGNETICS?/{END}		{aflag = 1;}
{S}MARKETS?/{END}		{aflag = 1;}
{S}MARRIOTT/{END}		{aflag = 1;}
{S}MERCURY/{END}		{aflag = 1;}
{S}MICRO			{aflag = 1;}
{S}MOTELS?/{END}		{aflag = 1;}
{S}MOTOR			{aflag = 1;}
{S}MOUNTAIN/{END}		{aflag = 1;}
{S}MOVERS/{END}			{aflag = 1;}
{S}MOVING/{END}			{aflag = 1;}
{S}MUSLIM/{END}			{aflag = 1;}
{S}MUTUAL/{END}			{aflag = 1;}
{S}NAVY/{END}			{aflag = 1;}
{S}NET(WORK)?/{END}		{aflag = 1;}
{S}NUMBER/{END}			{aflag = 1;}
{S}OF/{END}			{aflag = 1;}
{S}OFFICE/{END}			{aflag = 1;}
{S}OIL/{END}			{aflag = 1;}
{S}ON/{END}			{aflag = 1;}
{S}ONLINE/{END}			{aflag = 1;}
{S}OPERATION(S)?/{END}		{aflag = 1;}
{S}OPTICS?/{END}		{aflag = 1;}
{S}OUTDOOR/{END}		{aflag = 1;}
{S}OUTFITTERS?/{END}		{aflag = 1;}
{S}PASSWORD/{END}		{aflag = 1;}
{S}PATHOLOGY/{END}		{aflag = 1;}
{S}PATROL/{END}			{aflag = 1;}
{S}PC/{END}			{aflag = 1;}
{S}PERCISION/{END}		{aflag = 1;}
{S}PERFORMANCE/{END}		{aflag = 1;}
{S}PERSONAL/{END}		{aflag = 1;}
{S}PHARMACY/{END}		{aflag = 1;}
{S}PHOTO(GRAPHY?)?/{END}	{aflag = 1;}
{S}PIZZA/{END}			{aflag = 1;}
{S}PLUMBING/{END}		{aflag = 1;}
{S}PLUS				{aflag = 1;}
{S}POWER			{aflag = 1;}
{S}PRACTICE/{END}		{aflag = 1;}
{S}PRESS/{END}			{aflag = 1;}
{S}PRINT(ING)?/{END}		{aflag = 1;}
{S}PRODUCTIONS/{END}		{aflag = 1;}
{S}PUBLIC/{END}			{aflag = 1;}
{S}PUBLISHING/{END}		{aflag = 1;}
{S}QUALITY/{END}		{aflag = 1;}
{S}RADIO/{END}			{aflag = 1;}
{S}RADISSON/{END}		{aflag = 1;}
{S}RANCH/{END}			{aflag = 1;}
{S}REALT(Y|(ORS?))/{END}	{aflag = 1;}
{S}REPAIR/{END}			{aflag = 1;}
{S}RESEARCH/{END}		{aflag = 1;}
{S}RESERVATIONS/{END}		{aflag = 1;}
{S}RESTURANT/{END}		{aflag = 1;}
{S}ROCKET/{END}			{aflag = 1;}
{S}ROUND(UP)?/{END}		{aflag = 1;}
{S}SAVINGS/{END}		{aflag = 1;}
{S}SCIENCES?/{END}		{aflag = 1;}
{S}SEAFOOD/{END}		{aflag = 1;}
{S}SECRETS?/{END}		{aflag = 1;}
{S}SERVICE(S)?/{END}		{aflag = 1;}
{S}SHACK/{END}			{aflag = 1;}
{S}SHOP/{END}			{aflag = 1;}
{S}SOCIETY/{END}		{aflag = 1;}
{S}SOFTWARE/{END}		{aflag = 1;}
{S}SOLUTIONS/{END}		{aflag = 1;}
{S}SPEED/{END}			{aflag = 1;}
{S}SPORTS?/{END}		{aflag = 1;}
{S}SQUARE/{END}			{aflag = 1;}
{S}STATIONERS?/{END}		{aflag = 1;}
{S}STORAGE/{END}		{aflag = 1;}
{S}STORE/{END}			{aflag = 1;}
{S}STUDIOS/{END}		{aflag = 1;}
{S}SUPER			{aflag = 1;}
{S}SYMBOLS?/{END}		{aflag = 1;}
{S}SYSTEMS/{END}		{aflag = 1;}
{S}TAXIDERMY/{END}		{aflag = 1;}
{S}TECHNICAL/{END}		{aflag = 1;}
{S}TECHNOLOG			{aflag = 1;}
{S}TELE[A-Z]+/{END}		{aflag = 1;}
{S}TEMPLE/{END}			{aflag = 1;}
{S}TESTS?/{END}			{aflag = 1;}
{S}THEATER/{END}		{aflag = 1;}
{S}THINKING/{END}		{aflag = 1;}
{S}TICKET			{aflag = 1;}
{S}TIRES?/{END}			{aflag = 1;}
{S}TOYS?/{END}			{aflag = 1;}
{S}TRAIL/{END}			{aflag = 1;}
{S}TRANSFERS?/{END}		{aflag = 1;}
{S}TRANSIT/{END}		{aflag = 1;}
{S}TRAVEL/{END}			{aflag = 1;}
{S}TRUCKING/{END}		{aflag = 1;}
{S}TRUST/{END}			{aflag = 1;}
{S}TYPO				{aflag = 1;}
{S}UNION/{END}			{aflag = 1;}
{S}UNITED/{END}			{aflag = 1;}
{S}USA/{END}			{aflag = 1;}
{S}UTILITY/{END}		{aflag = 1;}
{S}VANTAGE/{END}		{aflag = 1;}
{S}VENTURE			{aflag = 1;}
{S}VICTORIAN/{END}		{aflag = 1;}
{S}VIDO/{END}			{aflag = 1;}
{S}VINEYARD/{END}		{aflag = 1;}
{S}VISION/{END}			{aflag = 1;}
{S}VOLKSWAGEN/{END}		{aflag = 1;}
{S}VW/{END}			{aflag = 1;}
{S}WAREHOUSE/{END}		{aflag = 1;}
{S}WOMEN('S)?/{END}		{aflag = 1;}
{S}WORKS?/{END}			{aflag = 1;}
{S}WRITERS/{END}		{aflag = 1;}

{S}CAB/{END}			{aflag = 1;}
{S}AMC/{END}			{aflag = 1;}
{S}JEEP/{END}			{aflag = 1;}

{S}DSP/{END}			{aflag = 1;}
{S}ETC/{END}			{aflag = 1;}
{S}RGB/{END}			{aflag = 1;}
{S}HSB/{END}			{aflag = 1;}
{S}CYM/{END}			{aflag = 1;}
{S}CYMK/{END}			{aflag = 1;}

{S}alpha/{END}			{aflag = 1;}
{S}beta/{END}			{aflag = 1;}
{S}gamma/{END}			{aflag = 1;}
{S}delta/{END}			{aflag = 1;}
{S}epsilon/{END}		{aflag = 1;}
{S}theta/{END}			{aflag = 1;}
{S}omega/{END}			{aflag = 1;}

{S}first/{END}			{aflag = 1;}
{S}second/{END}			{aflag = 1;}
{S}third/{END}			{aflag = 1;}
{S}fourth/{END}			{aflag = 1;}
{S}fifth/{END}			{aflag = 1;}
{S}sixth/{END}			{aflag = 1;}
{S}seventh/{END}		{aflag = 1;}
{S}eighth/{END}			{aflag = 1;}
{S}ninth/{END}			{aflag = 1;}
{S}tenth/{END}			{aflag = 1;}


{S}western/{END}		{aflag = 1;}
{S}eastern/{END}		{aflag = 1;}
{S}southern/{END}		{aflag = 1;}
{S}northern/{END}		{aflag = 1;}

{S}one/{END}			{aflag = 1;}
{S}two/{END}			{aflag = 1;}
{S}three/{END}			{aflag = 1;}
{S}four/{END}			{aflag = 1;}
{S}five/{END}			{aflag = 1;}
{S}six/{END}			{aflag = 1;}
{S}seven/{END}			{aflag = 1;}
{S}eight/{END}			{aflag = 1;}

{S}nine/{END}			{aflag = 1;}
{S}ten/{END}			{aflag = 1;}
{S}hundred/{END}		{aflag = 1;}
{S}thousand/{END}		{aflag = 1;}

\001[ ]+The/{END}		{aflag = 1;}

{S}GLOBE/{END}			{aflag = 1;}
{S}TIMES/{END}			{aflag = 1;}
{S}NEWS/{END}			{aflag = 1;}
{S}HERALD/{END}			{aflag = 1;}
{S}NEWSDAY/{END}		{aflag = 1;}
{S}INQUIRER/{END}		{aflag = 1;}
{S}ENQUIRER/{END}		{aflag = 1;}
{S}EXAMINER/{END}		{aflag = 1;}
{S}MAGAZINE/{END}		{aflag = 1;}
{S}MAIL/{END}			{aflag = 1;}
{S}JOURNAL/{END}		{aflag = 1;}
{S}GAZETTE/{END}		{aflag = 1;}
{S}REVIEW/{END}			{aflag = 1;}
{S}TRIBUNE/{END}		{aflag = 1;}
{S}MEDIA/{END}			{aflag = 1;}

{S}WRECK(ING)?/{END}		{aflag = 1;}
{S}RENT/{END}			{aflag = 1;}
{S}HAUL/{END}			{aflag = 1;}

{S}LINUX/{END}			{aflag = 1;}
{S}SOLARIS/{END}		{aflag = 1;}
{S}UNIX/{END}			{aflag = 1;}
{S}WINDOWS/{END}		{aflag = 1;}
{S}MAC(INTOSH)?/{END}		{aflag = 1;}

{S}COMMONWEALTH/{END}		{aflag = 1;}
{S}COUNTRY/{END}		{aflag = 1;}
{S}COUNTY/{END}			{aflag = 1;}
{S}STATE/{END}			{aflag = 1;}
{S}NATIONAL/{END}		{aflag = 1;}
{S}GLOBAL/{END}			{aflag = 1;}
{S}FEDERAL/{END}		{aflag = 1;}
{S}FEDERATED/{END}		{aflag = 1;}
{S}INT"'"L/{END}		{aflag = 1;}
{S}INTERNATIONAL/{END}		{aflag = 1;}

{S}ASIAN/{END}			{aflag = 1;}
{S}AFRIC(A|IAN)/{END}		{aflag = 1;}
{S}EUROPE(AN)?/{END}		{aflag = 1;}
{S}MEXICIAN/{END}		{aflag = 1;}
{S}CANADIAN/{END}		{aflag = 1;}
{S}AMERICAN/{END}		{aflag = 1;}
{S}ATLANTIC/{END}		{aflag = 1;}
{S}PACIFIC/{END}		{aflag = 1;}


{S}ENTWICKLUNGS/{END}		{aflag = 1;}
{S}GMBH/{END}			{aflag = 1;}
{S}INC/{END}			{aflag = 1;}
{S}LTD/{END}			{aflag = 1;}
{S}LDA/{END}			{aflag = 1;}
{S}SOFCWARE/{END}		{aflag = 1;}
{S}SYSTEMES/{END}		{aflag = 1;}


%%
int	parse_company(const char *buf)
{
	char	*mbuf	= (char*)alloca(strlen(buf)+16);
	char	*cc;
	const	char *dd;

	//if(0)	yyunput(0,0);

	cc	= mbuf;
	*cc++	= 1;			/* begin with control-a */
	*cc++	= ' ';
	for(dd=buf;*dd;dd++,cc++){
		*cc = (*dd & 0x7f);
		if(*cc == '\t') *cc = ' ';
	}
	*cc++	= ' ';
	*cc++	= ' ';
	*cc++	= ' ';
	*cc++	= 26;			/* end with a control-z */
	*cc++	= EOF;
	*cc++	= '\000';
	
	lptr	= mbuf;
	aflag	= 0;


	/* initialize flex static variables */
	yy_init			= 1;
	yy_current_buffer	= 0;
	yy_c_buf_p 		= 0;
	yy_start		= 0;
	yyin			= 0;
	yyout			= 0;
	Yeof			= 0;

	yylex();

	yy_delete_buffer(yy_current_buffer);
	yy_current_buffer	= 0;
	return aflag;
}

