%{
/* month parser built out of flex.
 * Searches for a month string and returns its number.
 */

static 	int	month;
static	char	*lptr;

#define	MIN(x,y) ((x)<(y) ? (x) : (y))
#undef  YY_INPUT
#define	YY_INPUT(buf,result,max_size)\
		result=MIN(strlen(lptr),max_size);\
		memcpy(buf,lptr,result);\
		lptr+=result;
#undef 	ECHO
#define	ECHO {}
			
%}

END	[^a-zA-Z]

%%

[jJ][aA][nN]([uU][aA][rR][yY])?{END}		{month=0;}
[fF][eE][bB]([rR][uU][aA][rR][yY])?{END}	{month=1;}
[mM][aA][rR]([cC][hH])?{END}			{month=2;}
[aA][pP][rR]([iI][lL])?{END}			{month=3;}
[mM][aA][yY]{END}				{month=4;}
[jJ][uU][nN]([eE])?{END}			{month=5;}
[jJ][uU][lL]([yY])?{END}			{month=6;}
[aA][uU][gG]([uU][sS][tT])?{END}		{month=7;}
[sS][eE][pP]([tT][eE][mM][bB][eE][rR])?{END}	{month=8;}
[oO][cC][tT]([oO][bB][eE][rR])?{END}		{month=9;}
[nN][oO][vV]([eE][mM][bB][eE][rR])?{END}	{month=10;}
[dD][eE][cC]([eE][mM][bB][eE][rR])?{END} 	{month=11;}

.						{/* null rule --- ignore */}
%%
int	parse_month(char *buf,struct tm *tm)
{
	char	*alloca(int size);
	char	*mbuf	= alloca(strlen(buf)+2);

	strcpy(mbuf,buf);
	strcat(mbuf," ");
	lptr	= mbuf;
	month	= -1;


	/* initialize flex static variables */
	yy_current_buffer	= 0;
	yy_c_buf_p 		= (YY_CHAR *)0;
	yy_init			= 1;		/* be sure to init */
	yy_start		= 0;
	yyin			= (FILE *)0;
	yyout			= (FILE *)0;
	yylex();

	return(month);
	return;
}

